<template>
  <ob-form
    ref="add-form"
    :form-data="formData"
    :form-model="formModel"
    :isShowControls="true"
    okText="Создать"
    cancelText="Отменить"
    data-qa="tenderAddForm"
    @submit="onSubmitHandler"
    @close="onClose"
  >
    <div class="ob-modal-container">
      <div class="modal-body">

        <div class="row">
          <div class="col-xs-12">
            <ob-textarea
              label="Краткое название тендера"
              placeholder="Должно отличаться от других названий и отражать суть тендера "
              exact-height="72px"
              max-length="53"
              v-model="formData.title"
              data-qa="title"
              @input="onInputTitle"
            />
          </div>
        </div>

        <div class="row">
          <div class="col-xs-12">
            <ob-textarea
              label="Описание тендера"
              placeholder="Опишите цели, задачи тендера, его ключевые признаки "
              v-model="formData.description"
              data-qa="description"
            />
          </div>
        </div>

         <div class="row">
          <div class="col-xs-6">
            <ob-datepicker
              ref="targetFinishDt"
              v-model="formData.targetFinishDt"
              @open="setDateState('targetFinishDt')"
              @focus="setDateState('targetFinishDt')"
              :date-validation-message="getValidationMessage()"
              :is-valid-date="isDateValid('targetFinishDt')"
              :since-to="disabledDate"
              :is-time="true"
              label="Завершение сбора предложений"
              placeholder="Укажите дату и время"
              data-qa="targetFinishDt"
            />
          </div>
          <div class="col-xs-6">
            <ob-datepicker
              ref="summarizingDt"
              v-model="formData.summarizingDt"
              @open="setDateState('summarizingDt')"
              @focus="setDateState('summarizingDt')"
              :date-validation-message="getValidationMessage('summarizingDt')"
              :is-valid-date="isSummarizingDtValid"
              :since-to="disabledDate"
              :is-time="true"
              label="Окончание подведения итогов"
              placeholder="Укажите дату и время"
              data-qa="summarizingDt"
            />
          </div>
        </div>

        <div class="timezone-text">Время указывается по часовому поясу Москвы UTC+3</div>

        <div class="row">
          <div class="col-xs-12">
            <ob-textarea
              label="Контактное лицо организатора"
              placeholder="Напишите имя сотрудника, который будет курировать тендер, его телефон и электронная почту"
              v-model="formData.contacts"
              data-qa="contacts"
            />
          </div>
        </div>
      </div>
    </div>
  </ob-form>
</template>

<script>
  import ObTextarea from 'common-components/src/obComponents/obTextarea';
  import ObForm from "common-components/src/obComponents/obForm";
  import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
  import DatesValidationMixin from "./../mixins/datesValidation";
  import { required } from "vuelidate/lib/validators";

  export default {
    name: 'tenders-add',
    mixins: [
      FormValidationMixin,
      DatesValidationMixin
    ],
    components: {
      ObForm,
      ObTextarea
    },
    props: {
      type: {
        type: String,
        required: true
      }
    },
    computed: {
      formModel() {
        return {
          title: {
            value: '',
            validator: {
              required
            }
          },
          description: {
            value: '',
            validator: {
              required
            }
          },
          targetFinishDt: {
            value: '',
            validator: {
              required,
              isValid: () => this.isDateValid('targetFinishDt')
            }
          },
          summarizingDt: {
            value: '',
            validator: {
              required,
              isValid: () => this.isSummarizingDtValid
            }
          },
          contacts: {
            value: '',
            validator: {
              required
            }
          }
        }
      }
    },
    methods: {
      // 👂 Events
      onClose() {
        this.$emit('close');
      },
      onSubmitHandler() {
        this.$emit('save', this.formData);
      },
      onInputTitle(value) {
        this.$nextTick(() => {
          // https://oboz.myjetbrains.com/youtrack/issue/CMN-1093
          this.formData.title = value.replace(/[/\\|:*?"<>]/gi, "_");
        })
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .timezone-text {
    @include font-mixin(12px, 12px, 400, $gray-slate, 0.4px);

    margin: -5px 0 20px;
  }
</style>
